unit _inifile;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Buttons, INIFiles;

function GetSepSpaceStr(str:string):string;
procedure LoadINI;
procedure SaveINI;

implementation

uses MainWin,SelDrvWin,SetuppedWin;

function GetSepSpaceStr(str:string):string;
var
  p:integer;
begin
  p:=ansipos(' ',str);

  if p=0 then begin
    Result:=str;
    end else begin
    Result:=copy(str,1,p-1);
  end;
end;

procedure LoadINI;
var
  fini:TINIFile;
  Section:string;
  idx:integer;
  procedure SetListStr(Section:string;ID:string;Lst:TComboBox);
  var
    idx:integer;
    str:string;
  begin
    str:=GetSepSpaceStr(fini.ReadString(Section,ID,''));
    for idx:=0 to Lst.Items.Count-1 do begin
      if GetSepSpaceStr(Lst.Items[idx])=str then Lst.ItemIndex:=idx;
    end;
  end;
  procedure SetListStrCP(Section:string;ID:string;Lst:TComboBox);
  var
    idx:integer;
    str:string;
  begin
    str:=GetSepSpaceStr(fini.ReadString(Section,ID,''));
    for idx:=0 to Lst.Items.Count-1 do begin
      if GetSepSpaceStr(copy(Lst.Items[idx],3,255))=str then Lst.ItemIndex:=idx;
    end;
  end;
begin
  fini:=TINIFile.Create(ChangeFileExt(Application.ExeName,'.ini'));

  Section:='system';

  SetListStr(Section,'TargetDrive',SelDrv.TargetDriveLst);
  Main.sysExistBackupChk.Checked:=fini.ReadBool(Section,'ExistBackup',Main.sysExistBackupChk.Checked);
  Setupped.OpenMoonshlINIChk.Checked:=fini.ReadBool(Section,'OpenMoonshlINI',Setupped.OpenMoonshlINIChk.Checked);

  Section:='configuration';

  Main.confMoonshlINIChk.Checked:=fini.ReadBool(Section,'moonshl.ini',Main.confMoonshlINIChk.Checked);
  Main.confStartupMP3Chk.Checked:=fini.ReadBool(Section,'startup.mp3',Main.confStartupMP3Chk.Checked);
  Main.confShutdownMP3Chk.Checked:=fini.ReadBool(Section,'shutdown.mp3',Main.confShutdownMP3Chk.Checked);
  Main.confPluginChk.Checked:=fini.ReadBool(Section,'plugin',Main.confPluginChk.Checked);
  Main.confResumeChk.OnClick:=nil;
  Main.confResumeChk.Checked:=fini.ReadBool(Section,'resume',Main.confResumeChk.Checked);
  Main.confResumeChk.OnClick:=Main.confResumeChkClick;
  Main.confBookmarkChk.OnClick:=nil;
  Main.confBookmarkChk.Checked:=fini.ReadBool(Section,'bookmark',Main.confBookmarkChk.Checked);
  Main.confBookmarkChk.OnClick:=Main.confBookmarkChkClick;
  Main.confBuiltinPluginChk.Checked:=fini.ReadBool(Section,'BuiltinPlugin',Main.confBuiltinPluginChk.Checked);
  Main.confCustomChk.Checked:=fini.ReadBool(Section,'Custom',Main.confCustomChk.Checked);

  Section:='clock';

  Main.clockUpdateChk.Checked:=fini.ReadBool(Section,'Update',Main.clockUpdateChk.Checked);
  SetListStr(Section,'Name',Main.clockNameLst);

  Section:='language';

  Main.langUpdateChk.Checked:=fini.ReadBool(Section,'Update',Main.langUpdateChk.Checked);
  SetListStrCP(Section,'CodePage',Main.langCodePageLst);
  Main.langAllItemChk.Checked:=fini.ReadBool(Section,'AllItemChk',Main.langAllItemChk.Checked);

  Section:='rom';

  for idx:=0 to GetDLDICount-1 do begin
    Main.NDSROMLst.Checked[idx]:=fini.ReadBool(Section,GetDLDIName(idx),Main.NDSROMLst.Checked[idx]);
  end;

  fini.Free;
end;

procedure SaveINI;
var
  fini:TINIFile;
  Section:string;
  idx:integer;
begin
  fini:=TINIFile.Create(ChangeFileExt(Application.ExeName,'.ini'));

  Section:='system';

  fini.WriteString(Section,'TargetDrive',GetSepSpaceStr(SelDrv.TargetDriveLst.Text));
  fini.WriteBool(Section,'ExistBackup',Main.sysExistBackupChk.Checked);
  fini.WriteBool(Section,'OpenMoonshlINI',Setupped.OpenMoonshlINIChk.Checked);

  Section:='configuration';

  fini.WriteBool(Section,'moonshl.ini',Main.confMoonshlINIChk.Checked);
  fini.WriteBool(Section,'startup.mp3',Main.confStartupMP3Chk.Checked);
  fini.WriteBool(Section,'shutdown.mp3',Main.confShutdownMP3Chk.Checked);
  fini.WriteBool(Section,'plugin',Main.confPluginChk.Checked);
  fini.WriteBool(Section,'resume',Main.confResumeChk.Checked);
  fini.WriteBool(Section,'bookmark',Main.confBookmarkChk.Checked);
  fini.WriteBool(Section,'BuiltinPlugin',Main.confBuiltinPluginChk.Checked);
  fini.WriteBool(Section,'Custom',Main.confCustomChk.Checked);

  Section:='clock';

  fini.WriteBool(Section,'Update',Main.clockUpdateChk.Checked);
  fini.WriteString(Section,'Name',Main.clockNameLst.Text);

  Section:='language';

  fini.WriteBool(Section,'Update',Main.langUpdateChk.Checked);
  fini.WriteString(Section,'CodePage',GetSepSpaceStr(copy(Main.langCodePageLst.Text,3,255)));
  fini.WriteBool(Section,'AllItemChk',Main.langAllItemChk.Checked);

  Section:='rom';

  for idx:=0 to Main.NDSROMLst.Items.Count-1 do begin
    fini.WriteBool(Section,GetDLDIName(idx),Main.NDSROMLst.Checked[idx]);
  end;

  fini.Free;
end;

end.
