
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <NDS.h>

#include "filesysARM7.h"

#include "_console.h"

#include "../../ipc3.h"

int FileSys_GetFileSize(void)
{
  return(IPC3->IR_filesize);
}

int FileSys_MP2_fread(void *buf,int size)
{
  while(IPC3->IR!=IR_NULL){
    swiDelay(1);
  }
  
  while(1){
    if(size<=IPC3->IR_readbufsize){
      break;
      }else{
      if(IPC3->IR_EOF==true){
        size=IPC3->IR_readbufsize;
        break;
      }
    }
  }
  
  if(size==0) return(0);
  
  DMA2_SRC = (u32)IPC3->IR_readbuf;
  DMA2_DEST = (u32)buf;
  DMA2_CR=(DMA_16_BIT | DMA_ENABLE | DMA_START_NOW | DMA_SRC_INC | DMA_DST_INC)+(size/2);
  
  IPC3->IR_readsize=size;
  IPC3->IR=IR_MP2_fread;
  
  REG_IPC_SYNC|=IPC_SYNC_IRQ_REQUEST;
  
  return(size);
}

int FileSys_OGG_fread(void *buf,int size)
{
  //_consolePrintf("OGG_fread(0x%x,%d,0x%x,0x%x);\n",(u32)buf,size,IPC3->IR_readbuf,__current_sp());
  
  while(IPC3->IR!=IR_NULL){
    swiDelay(1);
  }
  
  while(1){
    if(size<=IPC3->IR_readbufsize){
      break;
      }else{
      if(IPC3->IR_EOF==true){
        size=IPC3->IR_readbufsize;
        break;
      }
    }
  }
  
  if(size==0) return(0);
  
  u8 *psrc=(u8*)IPC3->IR_readbuf;
  u8 *pdst=(u8*)buf;
  u32 idx;
  for(idx=0;idx<size;idx++){
    pdst[idx]=psrc[idx];
//    _consolePrintf("%02x ",pdst[idx]);
  }
  
  IPC3->IR_readsize=size;
  IPC3->IR=IR_OGG_fread;
  
  REG_IPC_SYNC|=IPC_SYNC_IRQ_REQUEST;
  
  //_consolePrintf("readed %dbyte.\n",size);
  return(size);
}

void FileSys_OGG_fseek(int ofs)
{
  //_consolePrintf("OGG_fseek(%d);\n",ofs);
  
  IPC3->IR_readsize=ofs;
  IPC3->IR=IR_OGG_fseek;
  REG_IPC_SYNC|=IPC_SYNC_IRQ_REQUEST;
  
  while(IPC3->IR!=IR_NULL){
    swiDelay(1);
  }
  //_consolePrint("fseek end\n");
}
