#pragma Otime

#include "_memory.h"
#include "../memtool.h"
#include "../_console.h"

#undef _ogg_calloc
#undef _ogg_malloc
#undef _ogg_free
#undef _ogg_realloc

void *_ogg_calloc(size_t nmemb, size_t size)
{
  return(safemalloc(nmemb*size));
}

void *_ogg_malloc(size_t size)
{
  return(safemalloc(size));
}

void _ogg_free(void *ptr)
{
  safefree(ptr);
}

void *_ogg_realloc(void *ptr, size_t size)
{
  safefree(ptr);
  return(safemalloc(size));
}

#ifdef LINEDEBUG

void *D_ogg_calloc(const char *pfn,int line,size_t nmemb, size_t size)
{
  char *seek=(char*)pfn;
  
  while(*seek!=0){
    if(*seek=='\\') pfn=seek;
    seek++;
  }
  
  _consolePrintf("%s:%d calloc(%d);\n",pfn,line,size);
  return(_ogg_calloc(nmemb,size));
}

void *D_ogg_malloc(const char *pfn,int line,size_t size)
{
  char *seek=(char*)pfn;
  
  while(*seek!=0){
    if(*seek=='\\') pfn=seek;
    seek++;
  }
  
  _consolePrintf("%s:%d malloc(%d);\n",pfn,line,size);
  return(_ogg_malloc(size));
}

void D_ogg_free(const char *pfn,int line,void *ptr)
{
  char *seek=(char*)pfn;
  
  while(*seek!=0){
    if(*seek=='\\') pfn=seek;
    seek++;
  }
  
  _consolePrintf("%s:%d free(0x%x);\n",pfn,line,(u32)ptr);
  return(_ogg_free(ptr));
}

void *D_ogg_realloc(const char *pfn,int line,void *ptr, size_t size)
{
  char *seek=(char*)pfn;
  
  while(*seek!=0){
    if(*seek=='\\') pfn=seek;
    seek++;
  }
  
  _consolePrintf("%s:%d realloc(0x%x,%d);\n",pfn,line,(u32)ptr,size);
  return(_ogg_realloc(ptr,size));
}

#endif
