
static int MWinSystemMenu_DefaultIndex;
static int MWinSystemMenu_LastIndex;

static void MWinCallSystemIcon_Draw(u32 WinIndex)
{ cwl();
  TWinBody *pwb=MWin_GetWinBody(WinIndex);
  TSkinBM *pSkinBM=MWin_GetSkinBM();
  
  if(pwb->WinBuf==NULL) return;
  if(pSkinBM->pSystemIconBM==NULL) return;
  
  u16 *pDstBuf=pwb->WinBuf;
  u16 *pDesktopBuf=&pSkinBM->pDesktopBM[0];
  u16 *pIconBuf=&pSkinBM->pSystemIconBM[0];
  
  for(s32 y=0;y<16;y++){ cwl();
    for(s32 x=0;x<16;x++){ cwl();
      if(pIconBuf[x]!=0){ cwl();
        pDstBuf[x]=pIconBuf[x];
        }else{
        pDstBuf[x]=pDesktopBuf[x];
      }
     }
    pDstBuf+=16;
    pDesktopBuf+=ScreenWidth;
    pIconBuf+=16;
  }
}

static void MWinCallSystemIcon_MouseDown(u32 WinIndex,s32 x,s32 y)
{ cwl();
  
  int idx=-1;
  switch(GlobalINI.TextPlugin.TextEncode){
    case EITPTE_Local: idx=0; break;
    case EITPTE_UTF8: idx=1; break;
    case EITPTE_UTF16LE: idx=2; break;
    case EITPTE_UTF16BE: idx=3; break;
  }
  MWinSystemMenu_DefaultIndex=idx;
  
  MWinSystemMenu_LastIndex=-1;
  
  MWin_SetVisible(WM_SystemMenu,true);
  WinIndex=MWin_SetActive(WM_SystemMenu);
  MWin_RefreshScreenMask();
  if(WinIndex!=(u32)-1) MWin_RefreshWindow(WinIndex);
  MWin_RefreshWindow(WM_SystemMenu);
}

static void MWinCallSystemIcon_MouseMove(u32 WinIndex,s32 x,s32 y)
{ cwl();
  Global_MouseMove(WinIndex,x,y);
}

static void MWinCallSystemIcon_MouseUp(u32 WinIndex,s32 x,s32 y)
{ cwl();
  Global_MouseUp(WinIndex,x,y);
}

// -------------------

static void MWinCallSystemMenu_Draw(u32 WinIndex)
{ cwl();
  TWinBody *pwb=MWin_GetWinBody(WinIndex);
  
  s32 BufWidth=pwb->Rect.w;
  
  s32 wLimit=pwb->ClientRect.x+pwb->ClientRect.w;
  
  u16 *pBuf=&pwb->WinBuf[0];
  
  if(pwb->WinBuf==NULL) return;
  
  for(int idx=0;idx<SystemMenu_ItemCount;idx++){
    u32 ofsx=pwb->ClientRect.x;
    u32 ofsy=pwb->ClientRect.y;
    
    u16 bgcol=0;
    if(idx==MWinSystemMenu_DefaultIndex) bgcol=MWC_FrameBright;
    if(idx==MWinSystemMenu_LastIndex) bgcol=MWC_FrameDark;
    if(bgcol!=0){
      VRAM_SetCharLineRect(pBuf,BufWidth,ofsx,ofsy+(idx*SystemMenu_ItemHeight),pwb->ClientRect.w,SystemMenu_ItemHeight,bgcol);
    }
    
    u16 col=MWC_ClientText;
    u16 halfcol=ColorMargeAlpha(bgcol,col,8);
    
    switch(idx){
      case 4: {
        if(FileSys_GetFileType(FS_CursorIndex)!=FT_File) col=halfcol;
      } break;
      case 6: {
        if(isCustom()==false) col=halfcol;
      } break;
      case 7: {
        if(IPC3->isNDSLite==false) col=halfcol;
      } break;
      default: break;
    }
    
    ofsx+=2;
    ofsy+=(SystemMenu_ItemHeight-FontProHeight)/2;
    
    const char *pstr;
    
    if(idx<SystemMenu_MSEStartIndex){
      if(idx!=5){
        pstr=Lang_GetInternalIndex(ELI_SystemMenu,idx);
        }else{
        if(GlobalINI.System.LockLRButton==false){
          pstr=Lang_GetInternalIndex(ELI_SystemMenu,(idx*10)+0);
          }else{
          pstr=Lang_GetInternalIndex(ELI_SystemMenu,(idx*10)+1);
        }
      }
      }else{
      u32 mseidx=(u32)idx-SystemMenu_MSEStartIndex;
      if(mseidx<MSEList_GetCount()){
        pstr=MSEList_GetFilename(mseidx);
        }else{
        pstr=NULL;
      }
    }
    
    VRAM_WriteStringRectUTF8(pBuf,BufWidth,wLimit,ofsx,ofsy+(idx*SystemMenu_ItemHeight),pstr,col);
  }
}

static void MWinCallSystemMenu_MouseMove(u32 WinIndex,s32 x,s32 y);
static void MWinCallSystemMenu_MouseDown(u32 WinIndex,s32 x,s32 y)
{ cwl();
  MWinCallSystemMenu_MouseMove(WinIndex,x,y);
}

static void MWinCallSystemMenu_MouseMove(u32 WinIndex,s32 x,s32 y)
{ cwl();
  TWinBody *pwb=MWin_GetWinBody(WinIndex);
  
  int back=MWinSystemMenu_LastIndex;
  
  if((0<=x)&&(x<pwb->ClientRect.w)){
    MWinSystemMenu_LastIndex=y/SystemMenu_ItemHeight;
    }else{
    MWinSystemMenu_LastIndex=-1;
  }
  
  if(back==MWinSystemMenu_LastIndex) return;
  
  MWin_DrawClient(WM_SystemMenu);
  MWin_TransWindow(WM_SystemMenu);
}

static void MWinCallSystemMenu_MouseUp(u32 WinIndex,s32 x,s32 y)
{ cwl();
  MWinCallSystemMenu_MouseMove(WinIndex,x,y);
  
  if((MWinSystemMenu_LastIndex<0)||(SystemMenu_ItemCount<=MWinSystemMenu_LastIndex)) return;
  
  bool exectext=false,execbin=false,execlrlock=false,execenv=false,execbacklight=false;
  u32 execmse=(u32)-1;
  
  switch(MWinSystemMenu_LastIndex){
    case 0: GlobalINI.TextPlugin.TextEncode=EITPTE_Local; exectext=true; break;
    case 1: GlobalINI.TextPlugin.TextEncode=EITPTE_UTF8; exectext=true; break;
    case 2: GlobalINI.TextPlugin.TextEncode=EITPTE_UTF16LE; exectext=true; break;
    case 3: GlobalINI.TextPlugin.TextEncode=EITPTE_UTF16BE; exectext=true; break;
    case 4: execbin=true; break;
    case 5: execlrlock=true; break;
    case 6: execenv=true; break;
    case 7: execbacklight=true; break;
    default: {
      u32 mseidx=(u32)MWinSystemMenu_LastIndex-SystemMenu_MSEStartIndex;
      if(mseidx<MSEList_GetCount()) execmse=mseidx;
    } break;
  }
  
  if(execbacklight==false){
    MWin_SetVisible(WM_SystemMenu,false);
    MWin_SetActiveTopMost();
    MWin_RefreshScreenMask();
    MWin_AllRefresh();
  }
  
  if(exectext==true){
    Setting_Backup();
    FS_StartFromIndex(FS_CursorIndex,EM_Text);
  }
  
  if(execbin==true) FS_StartFromIndex(FS_CursorIndex,EM_BinView);
  
  if(execenv==true){
    if(isCustom()==true){
      FS_ExecuteStop();
      Setting_Backup();
      custom_main();
      while(1);
    }
  }
  
  if(execlrlock==true){
    if(GlobalINI.System.LockLRButton==false){
      GlobalINI.System.LockLRButton=true;
      }else{
      GlobalINI.System.LockLRButton=false;
    }
    Setting_Backup();
  }
  
  if(execbacklight==true){
    if(IPC3->isNDSLite==true){
      u32 Brightness=GlobalINI.System.NDSLiteDefaultBrightness;
      if(Brightness<3){
        Brightness++;
        }else{
        Brightness=0;
      }
      GlobalINI.System.NDSLiteDefaultBrightness=Brightness;
      Setting_Backup();
      NDSLite_SetBrightness(Brightness);
    }
  }
  
  if(execmse!=(u32)-1){
    const char *pstr=MSEList_GetFilename(execmse);
    if(MSEList_isExists(pstr)==true){
      MSE_Exec(pstr);
      while(1);
    }
  }
}

